---
title: Signing Micheline strings
status: Draft
author: Fred Yankowski (@fredcy)
type: Interface
created: 2022-05-04
date: 2022-05-18
version: 6
---


## Summary

This standard provides for *secure message signing*, a process such that
applications can ask an account owner to sign an off-chain message and the owner can be
sure that what they sign cannot have any affect on their on-chain assets.

## Abstract

Tezos applications sometimes need proof from the user that the user controls a
particular Tezos account or, more specifically, controls the account and agrees
with a particular statement.  One way to do this is for the application to
construct a message as a string value and ask the user to sign that string using
the secret key of the account. The flow goes as follows:

+ The application constructs the message string specific to the case at hand (see below).

+ The application encodes the message string as a Micheline string value.

+ The application requests that the account owner sign the Micheline string
value, passing it to the wallet in a signature-request via middleware such as
Beacon.

+ The wallet app gets the signature request. It presents the request to the user
for approval.  The wallet app should present the decoded message string to
the wallet user as readable text, along with the request for approval.

+ The user approves the signature request via the wallet UI.

+ The wallet responds to the signature request from the app, providing the
signature value generated by the wallet app.

+ The requesting application receives the signature response. It validates the
signature to confirm that it is correct. (It will need the public key of the
signing account to do this, in general).

+ If the signature is valid, the application proceeds with whatever depended on
the valid signature.

## Motivation

This standard documents a "temporary message signing" standard<sup>[1](#footnote1)</sup>
that has been in use since early 2021.

Prior to this temporary standard there was no well-known
method in Tezos for secure message signing.

The only well-known alternative for proving account ownership was to send a
small amount of tez to the requesting party.

## Specification

#### Payload

The payload to be signed is a simple
[Micheline](https://tezos.gitlab.io/shell/micheline.html#character-strings)
string expression, represented as a hex-encoding of the binary Micheline value.

The character codes composing the string value *must* all fall in the 7-bit ASCII range.

The string *must* be prefixed with "`Tezos Signed Message: `". That is 22 characters
including the final colon and space, which would be encoded in hex as
`54657a6f73205369676e6564204d6573736167653a20`.

This standard does not impose any other hard requirements on the content of that
string beyond what Micheline itself allows. But see the Security Consideration section below.

#### Text interchange format

This standard also defines a text interchange format for representing a message
and its signature in a single multi-line text block that can be read and verified as one
piece by suitable applications.

```
-----BEGIN TEZOS SIGNED MESSAGE-----
<message>
-----BEGIN SIGNATURE-----
<public key>
<signature>
-----END TEZOS SIGNED MESSAGE-----
```

1. The \<message\> component is the signed message, comprising 7-bit ASCII characters.

1. The \<message\> value will always start with the "Tezos Signed Message: "
prefix.

1. The \<public key\> and \<signature\> values each appear alone on a
line in the signature block, in that order.

### Example

#### Payload

Given a message string of "`Tezos Signed Message: mydapp.com 2021-01-14T15:16:04Z Hello world!`” the
JSON representation would be

```
{
  string: "Tezos Signed Message: mydapp.com 2021-01-14T15:16:04Z Hello world!"
}
```

and the encoding as bytes (represented as hex) would be

```
05010000004254657a6f73205369676e6564204d6573736167653a206d79646170702e636f6d20323032312d30312d31345431353a31363a30345a2048656c6c6f20776f726c6421
```

That bytes representation comprises these parts, in order:

+ `05`: Micheline expression prefix
+ `01`: Micheline string prefix
+ `00000042`: number of characters in the string (66 in this example)
+ `54657a6f7`...: the characters (7-bit ASCII) of the message

#### Text interchange format
Here is a sample, signed by a tz1 account:
```
-----BEGIN TEZOS SIGNED MESSAGE-----
Tezos Signed Message: I approve this tzip to become final.  2022-05-11
-----BEGIN SIGNATURE-----
edpkuQDW4jhXmqfi9ywGzc7MoEyMpkvmhws4SMFGsx9rxdHXsebiAr
edsigtvDqYnL62kshFBuCiX7ZvN7bpkoTFcUeBXcTYtWWLmMByp5yn67LMV1vDuAWkP4cyt1FXZXQu7r9aPCLAXQ6rAAVWMeUhe
-----END TEZOS SIGNED MESSAGE-----
```
## Rationale

Ledger is able to sign operations, prehashes, and Micheline expressions.  Of
those, [prehashes](https://github.com/obsidiansystems/ledger-app-tezos/blob/master/Release-1.3.md#unverified-operations) and operations are unsafe in general as they could amount to
arbitrary transactions or contract calls that could potentially access and
transfer away or destroy ownership of the owning account's on-chain
resources. Micheline strings are safer in that they would only be dangerous when
passed as an argument to a transaction that performs some unsafe action based on
the string's value.

The "Tezos Signed Message" prefix serves to distinguish strings used just for
message signing, the presumption being that no contract would perform unsafe
actions based on such a string value.

An alternative standard could be based on the
[`failing_noop` operation kind](https://tezos.gitlab.io/protocols/009_florence.html#new-failing-noop-operation)
introduced in the Florence protocol of Tezos.

## Backwards Compatibility

Not applicable

## Security Considerations

To prevent against replay attacks, this standard recommends that the message
include elements that restrict its context and bound it in time.  The example
given above includes "mydapp.com" to associate the message with that domain
(and, implicitly, application) and "2021-01-14T15:16:04Z" serves to time stamp
the message so that the application could refuse to accept signed values deemed
to be too old.

## Test Cases

See the example given in the Specification section above.

## Implementations

Here is Typescript code that can encode a string value as needed for a Beacon
signatureRequest payload. This assumes that the "Tezos Signed Message: " prefix
already appears in the input string.

```
import {Buffer} from 'buffer';

export function msgToBytes(msg : string) : string {
    const input = Buffer.from(msg);
    const prefix = Buffer.from("0501", "hex");
    const len_bytes = Buffer.from(msg.length.toString(16).padStart(8, '0'), "hex");
    const msgBuffer : Buffer = Buffer.concat([prefix, len_bytes, input], prefix.length + len_bytes.length + input.length);
    return msgBuffer.toString("hex");
}
```

Here is sample Beacon-SDK code for requesting a signature (also assuming the
prefix already appears in the `message` value):

```
async function sign(client: DAppClient, message : string) : Promise<string> {
    const signature = await client.requestSignPayload({
        payload: payload = crypto.msgToBytes(message),
        signingType: SigningType.MICHELINE,
    })
    return signature.signature
}

```

## References

<a name="footnote1">1</a>: Temporary signing standard:
https://docs.google.com/document/d/1ZgA7mZNrWl1YZ0snzjiFw1ahyXjvWFS1GvU5-caUDCE

## Copyright

Copyright and related rights waived via
[CC0](https://creativecommons.org/publicdomain/zero/1.0/).
